package org.apache.maven.artifact.deployer;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import org.apache.maven.MavenException;
import org.apache.maven.artifact.deployer.ArtifactDeployer;
import org.apache.maven.artifact.deployer.DefaultArtifactDeployer;
import org.apache.maven.project.Project;

/**
 * 
 * The Bean which provides access to Artifact Deployement API
 * from jelly scripts.
 * 
 * @author <a href="michal.maczka@dimatics.com">Michal Maczka</a> 
 * @version $Id: DeployBean.java,v 1.4 2004/03/02 14:59:31 evenisse Exp $
 */
public class DeployBean
{
    ArtifactDeployer artifactDeployer = null;

    private Project project = null;
    private String artifact = null;
    private String type = null;

    public DeployBean()
    {  
        artifactDeployer = new DefaultArtifactDeployer();
    }

    /**
     * @return
     */
    public String getArtifact()
    {
        return artifact;
    }

    /**
     * @param artifact
     */
    public void setArtifact(String artifact)
    {
        this.artifact = artifact;
    }

    /**
     * @return
     */
    public Project getProject()
    {
        return project;
    }

    /**
     * @param project
     */
    public void setProject(Project project)
    {
        this.project = project;
    }

    /**
     * @return
     */
    public String getType()
    {
        return type;
    }

    /**
     * @param type
     */
    public void setType(String type)
    {
        this.type = type;
    }

    /**
     * 
     * @throws MavenException
     */
    protected void checkAttributes() throws MavenException
    {
        if (project == null)
        {
            throw new MavenException("attribute 'project' is required");
        }

        if (artifact == null)
        {
            throw new MavenException("attribute 'artifact' is required");
        }
        if (type == null)
        {
            throw new MavenException("attribute 'type' is required");
        }
    }

    /**
     * 
     */
    public void deploy() throws MavenException
    {
        checkAttributes();
        artifactDeployer.deploy(artifact, type, project);
    }

    /**
     * 
     */
    public void deploySnapshot() throws MavenException
    {
        checkAttributes();
        artifactDeployer.deploySnapshot(artifact, type, project);
    }

    /**
     * 
     */
    public void install() throws MavenException
    {
        checkAttributes();
        artifactDeployer.install(artifact, type, project);
    }

    /**
     * 
     */
    public void installSnapshot() throws MavenException
    {
        checkAttributes();
        artifactDeployer.installSnapshot(artifact, type, project);
    }

}
